#include "design_patterns_creational.hpp"
  
int main() {

  {
    using namespace Creational_Patterns::Abstract_Factory;
    
    std::cout << "Example of Abstract Factory" << std::endl;

    Widget * w1 = new OSX_Button;
    Widget * w2 = new Windows_Button;
    
    w1->draw();
    w2->draw();
  }

  {
    using namespace Creational_Patterns::Builder;
    
    std::cout << "Example of Builder" << std::endl;

    Build * b = new SimpleBuilder();
    ClientClass * c = new ClientClass(b);

    c;
  }

  {
    using namespace Creational_Patterns::Factory_Method;
    
    std::vector<Base *> factory;

    std::cout << "Example of Factory" << std::endl;

    // here you can have multiple choices deferred to this level

    factory.push_back(new A);
    factory.push_back(new B);
  }

  {
    using namespace Creational_Patterns::Object_Pool;
    
    std::cout << "Example of Object Pool" << std::endl;

    Pool pool;
    pool.getObject();
  }

  {
    using namespace Creational_Patterns::Prototype;
   
    std::cout << "Example of Proto" << std::endl;

    Proto * collection[num_protos_];
 
    collection[0] = Proto::findAClone(type_a);
    std::cout << "\t type_a found the expected type=" << 
      (collection[0]->returnType()==type_a ? "yes" : "no" ) << std::endl;

    collection[1] = Proto::findAClone(type_b);
    std::cout << "\t type_b found the expected type=" << 
      (collection[0]->returnType()==type_b ? "yes" : "no" ) << std::endl;
  
  }

  {
    using namespace Creational_Patterns::Singleton;
   
    std::cout << "Example of Singleton" << std::endl;

    for (unsigned int i = 0 ; i < 100 ; ++i)
      Single::getInstance();
  }

}
